config/routes.rb
Rails.application.routes.draw do
  root to: 'dashboard#show'
  get 'locked' => 'pages#locked', as: :locked_screen
  get 'thankyou' => 'pages#thankyou', as: :thankyou_screen

  devise_for :staffs
  devise_for :users

  resources :tickets do
    member do
      put :feedback_submit
    end
    collection do
      get :search
    end
    resources :comments
  end

  resources :todos
  resources :products do
    collection do
        get :search
      end
  end
  resources :quotes
  resource :account, controller: :account
  resource :staff_account, controller: :staff_account
  resources :notifications do
    collection do
      put :mark_as_read
    end
  end

  namespace :manager do
    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :users
  end
 

  namespace :admin do
    resources :staffs
    
  end

  namespace :guest do
    resources :tickets
  end
  
  namespace :staff do
    resources :quotes do
      member do
        post :create_ticket
      end
    end



    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :tickets do
      member do
        put :feedback_submit
      end
      collection do
        get :search
      end
    end
    resources :clients do
      resources :users do
      collection do
        get :search
      end
    end
 
    end
  end

end

app/models/product.rb
class Product < ApplicationRecord
   validates :name, :asset_type, :brand, :asset_tag, presence: true

   has_one :assignment
   has_one :hardware_detail
   has_many :software_details
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  def new
    @product = Product.new
    @hardware_detail = HardwareDetail.new
    @software_detail = SoftwareDetail.new
    @assignment = Assignment.new
  end

  def create
    @product = Product.new(product_params)

    @hardware_detail = HardwareDetail.new(hardware_product_params)

    @software_detail = SoftwareDetail.new(software_product_params)
    

    @assignment = Assignment.new(assignment_params)
    

    if @product.valid? and @hardware_detail.valid? and @software_detail.valid? and @assignment.valid?
      @product.save

      @hardware_detail.product_id = @product.id
      @hardware_detail.save

      @software_detail.product_id = @product.id
      @software_detail.save

      @assignment.product_id = @product.id
      @assignment.save

    redirect_to products_path

    else 
    render action: "new"
    end

  end

  def edit
    @product = Product.find(params[:id])
    @hardware_detail = HardwareDetail.find_by(product_id: params[:id])
    @software_detail = SoftwareDetail.find_by(product_id: params[:id])
    @assignment = Assignment.find_by(product_id: params[:id])
  end


  def index
    @products = Product.all

    respond_to do |format|
      format.html
      format.csv do
        headers['Content-Disposition'] = "attachment; filename=\"products-list.csv\""
        headers['Content-Type'] ||= 'text/csv'
      end
      format.pdf do
        render pdf: "products-list", disposition: 'attachment', layout: 'pdf'
      end
    end

  end

  def search
    @products = Product.all
    if params[:search][:query].present?
      query = '%' + params[:search][:query] + '%'
      @products = @products.where("name LIKE ? OR brand LIKE ?", query, query)
    end
    render action: :index
  end

  def show
    @product = Product.find params[:id]
  end

  def update
    @product = Product.find params[:id]
    @product.update_attributes! product_params

    @hardware_detail = HardwareDetail.find_by(product_id: params[:id])
    @hardware_detail.update_attributes! hardware_product_params

    @software_detail = SoftwareDetail.find_by(product_id: params[:id])
    @software_detail.update_attributes! software_product_params

    @assignment = Assignment.find_by(product_id: params[:id])
    @assignment.update_attributes! assignment_params

    flash[:success]="Successfully updated"

   
    redirect_to product_path(@product)
  end

  def destroy
    product= Product.find(params[:id])
    product.destroy
    redirect_to products_path
  end
  
  private
    def product_params
      params.require(:product).permit(:name, :asset_type, :brand, :asset_tag, :quantity,:model_no, :description)
    end

    def hardware_product_params
      params.require(:hardware_detail).permit(:processor, :hdd, :ram, :serial_no, :purchase_date,:warranty, :add_on)
    end

    def software_product_params
      params.require(:software_detail).permit(:software_os_name, :product_key, :purchase_date, :expiry_date)
    end

    def assignment_params
      params.require(:assignment).permit(:location, :managed_by, :department, :used_by, :assigned_on,:attachment)
    end


end

app/helpers/products_helper.rb
module ProductsHelper
end

app/views/products/index.csv.erb
<%- headers = ['Name', 'Asset Type', 'Product', 'Asset Tag', 'Department'] -%>
<%= CSV.generate_line headers %>
<%- @products.each do |product| -%>
<%= CSV.generate_line([product.name, product.asset_type, product.brand, product.asset_tag, product.assignment.department]) -%>
<%- end -%>

app/views/products/index.html.erb
<div class="container-fluid">
    <div class="p-t-30">
        <div class="row">
            <div class="col-sm-12">
                <div class="card">
                    <div class="card-header">
                        <div class = "row" >
                            <div class ="col-xl-4">
                                <h5 class="card-header-text">product List</h5>
                            </div>
                            <div class ="col-xl-8">
                                <div class = "dropdown-primary dropdown f-right" >
                                    <button type="button" class="btn btn-inverse-primary waves-effect waves-light  dropdown-toggle" data-toggle="dropdown" data-placement="top" title="" data-original-title=".btn-inverse-primary">Export
                                    </button>
                                    <div class = "dropdown-menu dropdown-menu-right" role = "menu">
                                        <%= link_to 'CSV', products_path(format: :csv, status: params[:status]), class: 'dropdown-item waves-light waves-effect' %>
                                        <%= link_to 'PDF',products_path(format: :pdf, status: params[:status]), class: 'dropdown-item waves-light waves-effect' %>
                                    </div>
                                </div>
                                <%= link_to new_product_path, class: "btn btn-primary waves-effect waves-light f-right m-r-20 d-inline-block" do %>
                                    <i class="icofont icofont-plus m-r-5"></i> ADD New
                                <% end %>
                         
                            </div>
                        </div>
                        <br />
                        <div class="row">
                            <%= form_for OpenStruct.new(params[:search]), as: :search, url: search_products_path, method: :get do |f| %>
                                <div class="col-xl-6 f-right">
                                    <%= f.text_field :query %>
                                    <%= submit_tag "Search"%>
                                </div>
                            <% end %>
                        </div>
                    </div>
                    <div class="row">
                        <% if @products.present? %>
                            <div class="table-content p-l-30 p-r-30">
                                <div class="project-table">
                                    <div id="e-product-list_wrapper" class="dataTables_wrapper form-inline dt-bootstrap4 no-footer">
                                        <div class="row">
                                            <div class="col-md-12">
                                                <table id="e-product-list" class="table table-striped dt-responsive nowrap dataTable no-footer dtr-inline" width="100%" cellspacing="0" role="grid" style="width: 100%;">
                                                    <thead>
                                                        <tr role="row">
                                                            <th> Name </th>
                                                            <th>Asset type</th>
                                                            <th>Product</th>
                                                            <th>Asset Tag</th>
                                                            <th>Department</th>
                                                            <th>Actions</th>
                                                            
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                        <% @products.each do |product| %>

                                                            <tr>
                                                                <td><%= product.name %></td>
                                                                <td>
                                                                    <%= link_to product_path(product) do %>
                                                                        <%= product.asset_type %>
                                                                    <% end %>
                                                                </td>
                                                                <td><%= product.brand %></td>
                                                                <td><%= product.asset_tag %></td>
                                                                <td><%= product.assignment.try :department %></td>
                                                                <td><%= link_to edit_product_path(product) do %> 
                                                                <i class="icofont icofont-edit"></i><% end %> 
                                                                &nbsp;&nbsp;&nbsp;&nbsp;
                                                                <%= link_to product_path(product),style: 'color:#373a3c;',  method: :delete, data: { confirm: "You sure?"  } do %>
                                                                <i class="icofont icofont-ui-delete"></i><% end %></td>
                                                            </tr>
                                                        <% end %>
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        <% else %>
                            <div class="card-header">
                              <center class="p-t-50 p-b-50">
                                Sorry you don't have any Products
                                <br />
                                <br />
                              </center>
                            </div>
                        <% end %>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                
                                                

app/views/products/index.pdf.erb
<h3>Products</h3>
<table class="table" border='1'>

  <thead>
    <tr role="row">
      <th>#ID</th>
      <th>Name</th>
      <th>asset_type</th>
      <th>brand</th>
      <th>asset_tag</th>
      <th>department</th>
    </tr>
  </thead>

  <tbody>
    <% @products.each do |product| %>
      <tr>
          <td><%= product.id %></td>
          <td><%= product.name %></td>
          <td><%= product.asset_type %></td>
          <td><%= product.brand %></td>
          <td><%= product.asset_tag %></td>
          <td><%= product.assignment.department %></td>
      </tr>
    <% end %>
  </tbody>
  
</table>

app/views/products/show.html.erb
<div class="container-fluid">
  <div class="row">
    <div class="main-header" style="margin-top: 0px;">
      <h4>Inventory Assets</h4>
    </div>
  </div>
  <div class="card">
    <div class="card-block ">
      <div class="container">
        <div class="md-float-material">
          <div class="sub-title">
               <h5><%= @product.name %>'s &nbsp;&nbsp;<%= @product.asset_type %></h5> 
          </div>

          <ul class="nav nav-tabs md-tabs tabs-left b-none" role="tablist">
            <li class="nav-item">
              <a class="nav-link active" data-toggle="tab" href="#home5" role="tab" aria-expanded="false">Overview</a>
              <div class="slide"></div>
            </li>
            <li class="nav-item">
              <a class="nav-link" data-toggle="tab" href="#profile5" role="tab" aria-expanded="false">Hardware</a>
              <div class="slide"></div>
            </li>
            <li class="nav-item">
              <a class="nav-link " data-toggle="tab" href="#messages5" role="tab" aria-expanded="true">Software</a>
              <div class="slide"></div>
            </li>
            <li class="nav-item">
              <a class="nav-link" data-toggle="tab" href="#settings5" role="tab" aria-expanded="false">Assigned</a>
              <div class="slide"></div>
            </li>
          </ul>
          <!-- Tab panes -->
          <div class="tab-content tabs-left-content">
            <div class="tab-pane active" id="home5" role="tabpanel" aria-expanded="false">
                <p>
                  <table class="table m-0">
                    <tbody>
                      <tr>
                        <th scope="row">Asset Tag</th>
                        <td><%= @product.asset_tag %></td>
                      </tr>
                      <tr>
                        <th scope="row">Asset_type</th>
                        <td><%= @product.asset_type %></td>
                      </tr>
                      <tr>
                        <th scope="row">Quantity</th>
                        <td><%= @product.quantity %></td>
                      </tr>
                      <tr>
                        <th scope="row">product</th>
                        <td><%= @product.brand %></td>
                      </tr>
                      <tr>
                        <th scope="row">Model No</th>
                        <td><%= @product.model_no %></td>
                      </tr>
                      <tr>
                        <th scope="row">Product Description</th>
                        <td><%= @product.description.html_safe %></td>
                      </tr>
                    </tbody>
                  </table>
                </p>
            </div>
            <div class="tab-pane" id="profile5" role="tabpanel" aria-expanded="false">
                <p>
                  <table class="table m-0">
                    <tbody>
                      <tr>
                        <th scope="row">Processor</th>
                        <td><%= @product.hardware_detail.processor %></td>
                      </tr>
                      <tr>
                        <th scope="row">RAM</th>
                        <td><%= @product.hardware_detail.ram %></td>
                      </tr>
                      <tr>
                        <th scope="row">HDD</th>
                        <td><%= @product.hardware_detail.hdd %></td>
                      </tr>
                      <tr>
                        <th scope="row">Serial No</th>
                        <td><%= @product.hardware_detail.serial_no %></td>
                      </tr>
                      <tr>
                        <th scope="row">warranty</th>
                        <td><%= @product.hardware_detail.warranty %></td>
                      </tr>
                      <tr>
                        <th scope="row">Add On's</th>
                        <td><%= @product.hardware_detail.add_on %></td>
                      </tr>
                    </tbody>
                  </table>
                </p>
            </div>
            <div class="tab-pane " id="messages5" role="tabpanel" aria-expanded="true">
                <p>3. This is Photoshop's version of Lorem IpThis is Photoshop's version of Lorem Ipsum. Proin gravida nibh vel velit auctor aliquet. Aenean sollicitudin, lorem quis bibendum auctor, nisi elit consequat ipsum, nec sagittis sem nibh id elit. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor.
                    Aenean mas Cum sociis natoque penatibus et magnis dis.....</p>
            </div>
            <div class="tab-pane" id="settings5" role="tabpanel" aria-expanded="false">
              <p>
                <table class="table m-0">
                  <tbody>
                    <tr>
                      <th scope="row">Location</th>
                      <td><%= @product.assignment.location %></td>
                    </tr>
                    <tr>
                      <th scope="row">Department</th>
                      <td><%= @product.assignment.department %></td>
                    </tr>
                    <tr>
                      <th scope="row">Managed by</th>
                      <td><%= @product.assignment.managed_by %></td>
                    </tr>
                    <tr>
                      <th scope="row">Used by</th>
                      <td><%= @product.assignment.used_by %></td>
                    </tr>
                    <tr>
                      <th scope="row">Assigned On</th>
                      <td><%= @product.assignment.assigned_on %></td>
                    </tr>
                    <% if @product.assignment.attachment_file_name.present? %>
                      <tr>
                        <th scope="row">Attached file</th>
                          <td>
                            Attachment : <%= link_to @product.assignment.attachment_file_name, @product.assignment.attachment.url, target: "_blank" %>
                          </td>
                      </tr>
                     <% end %>
                  </tbody>
                </table>    
              </p>
            </div>
          </div>
          <div class="contact-card-button">
            <%= link_to 'Cancel', products_path, class: "btn btn-primary" %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>